



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>洛谷 P1330 封锁阳光大学 Label：染色问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">洛谷 P1330 封锁阳光大学 Label：染色问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 19:55:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>题目描述</h2>
<p>曹是一只爱刷街的老曹，暑假期间，他每天都欢快地在阳光大学的校园里刷街。河蟹看到欢快的曹，感到不爽。河蟹决定封锁阳光大学，不让曹刷街。</p>
<p>阳光大学的校园是一张由N个点构成的无向图，N个点之间由M条道路连接。每只河蟹可以对一个点进行封锁，当某个点被封锁后，与这个点相连的道路就被封锁了，曹就无法在与这些道路上刷街了。非常悲剧的一点是，河蟹是一种不和谐的生物，当两只河蟹封锁了相邻的两个点时，他们会发生冲突。</p>
<p>询问：最少需要多少只河蟹，可以封锁所有道路并且不发生冲突。</p>
<h2>输入输出格式</h2>
<p>输入格式：</p>
<p>第一行：两个整数N，M</p>
<p>接下来M行：每行两个整数A，B，表示点A到点B之间有道路相连。</p>
<p>输出格式：</p>
<p>仅一行：如果河蟹无法封锁所有道路，则输出&ldquo;Impossible&rdquo;，否则输出一个整数，表示最少需要多少只河蟹。</p>
<h2>输入输出样例</h2>
<div>
<div>输入样例#1：</p>
<pre class="prettyprint linenums">【输入样例1】<br />
3 3<br />
1 2<br />
1 3<br />
2 3

【输入样例2】<br />
3 2<br />
1 2<br />
2 3
</pre>
</div>
<div>输出样例#1：</p>
<pre class="prettyprint linenums">【输出样例1】<br />
Impossible

【输出样例2】<br />
1
</pre>
</div>
</div>
<h2>说明</h2>
<p>【数据规模】</p>
<p>1&lt;=N&lt;=10000，1&lt;=M&lt;=100000，任意两点之间最多有一条道路。</p>
<h3>代码</h3>
<blockquote><div>
<pre class="prettyprint linenums"> #include&lt;iostream&gt;<br />
 #include&lt;cstring&gt;<br />
 #include&lt;cstdio&gt;<br />
 #include&lt;algorithm&gt;<br />
 #include&lt;vector&gt;<br />
 using namespace std;<br />
 int n,m,a[],vis[],t[],v,u,ans;<br />
 vector&lt;int&gt; G[];

 int dfs(int v,int col){<br />
     vis[v]=;<br />
     a[v]=col;<br />
     t[col]++;<br />
     for(int i=;i&lt;G[v].size();i++){<br />
         int p=G[v][i];<br />
         if(vis[p]&amp;&amp;a[p]==a[v]) return ;<br />
         else<br />
             if(!vis[p])<br />
                 if(!dfs(p,col^)) return ;<br />
     }<br />
     return ;<br />
 }

 int main(){<br />
 //    freopen("01.in","r",stdin);<br />
     scanf("%d%d",&amp;n,&amp;m);<br />
     for(int i=;i&lt;=m;i++){<br />
         scanf("%d%d",&amp;u,&amp;v);<br />
         G[u].push_back(v);<br />
         G[v].push_back(u);<br />
     }

     for(int i=;i&lt;=n;i++){<br />
         if(!vis[i]){<br />
             vis[i]=;<br />
             t[]=t[]=;<br />
             if(!dfs(i,)){<br />
                 puts("Impossible");<br />
                 return ;<br />
             }<br />
             ans+=min(t[],t[]);<br />
         }<br />
     }<br />
     printf("%d\n",ans);<br />
     return ;<br />
 }</pre>
</div>
<p><strong>转载题解：</strong></p>
<p>题目要求每条边的两个端点有且只有一个被封锁，可以对图进行黑白染色，若不存在染色方案则无解，若存在染色方案则答案为两种颜色中所用次数较少的那种的次数。</p>
<p><strong>注意：</strong></p>
<p>1,图是不联通的,要多次dfs;//怎么老想到移动......</p>
<p>2,要选两种方案中次数最少的次数!!!</p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2ven38.html">android service 本地 远程 总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/49526z69.html">JVM 类加载过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1mo338.html">Linux 常见的trouble shooting故障排错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn13er38.html">python单&sol;双下划线使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1n6yzq.html">Spring国际化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zy0dk9.html">jsJqGrid</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz3gdl8.html">js 实现数据结构 -- 字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp24o0q.html">Spring定时器配置与运用，及Cron表达式的详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkpwoj8.html">&lbrack;Swift&rsqb;LeetCode315&period; 计算右侧小于当前元素的个数 &vert; Count of Smaller Numbers After Self</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r51e08.html">Nginx优化文件编写</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjlem39.html">bootgrid修改成可以全勾选和全取消勾选操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlldx00q.html">C&num; SpinWait 实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rx4yo9.html">hibernate二级缓存ehcache  hibernate配置详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9027eg3q.html">Navicat for Mysql 1045错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4perpeq.html">PXE&comma;ipmi&comma;bare metal</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r45zj78.html">Kamailio</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2x2lox9.html">JDK&lowbar;如何查看安装的jdk是32位还是64位？</a>
		</li>
						<li><a href="https://www.batexi.com/a/95peg4eq.html">Java 命令行编译项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1pzmm4q.html">ADB命令后台修改系统默认输入法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4m47p5q.html">mongodb多条件查询总结</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/g8e64rjq.html">数据结构和算法 &amp;ndash&semi; 3&period;堆栈和队列</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j6ey0q.html">Tabular Model下的ADOMD&period;NET</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8op5l1q.html">phpcms v9网站搬家更换域名的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qynrmg9.html">C&num;交互功能的演化</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7vg4jq.html">leetcode4568</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93r7dz9.html">通过jquery-qrcode在线生成二维码</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m6yd29.html">虚拟机下玩DXF</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93r3g09.html">已解决：Strict Standards&colon; Non-static method cls&lowbar;image&colon;&colon;gd&lowbar;version&lpar;&rpar; should not be called statically in&period;&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqldp369.html">Android Studio在导入eclipse的项目时一直卡在gradle&colon;Configure project</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxj4dv9.html">LoadRunner如何监控Tomcat性能</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
